#include <cmath>
#include <fstream>
#include "TRNSYS.h" //TRNSYS acess functions (allow to acess TIME etc.) 
//************************************************************************
// Object: Test
// IISiBat Model: Type205
// 
// Author: 
// Editor: 
// Date:	 October 17, 2014 last modified: October 17, 2014
// 
// 
// *** 
// *** Model Parameters 
// *** 
//			nodes_htf	- [3;3]
//			nodes_shell	- [3;3]
//			Tini	C [-Inf;+Inf]

// *** 
// *** Model Inputs 
// *** 
//			Tin	C [-Inf;+Inf]

// *** 
// *** Model Outputs 
// *** 
//			Tout	C [-Inf;+Inf]
//			Tshell_top	C [-Inf;+Inf]
//			Tshell_mid	C [-Inf;+Inf]
//			Tshell_bot	C [-Inf;+Inf]

// *** 
// *** Model Derivatives 
// *** 

// (Comments and routine interface generated by TRNSYS Studio)
//************************************************************************

//Declation of the pointers to the dynamically allocated arrays
double *stored, *Thtf, *Thtf_old, **Tshell, **Tshell_old;

//
extern "C" __declspec(dllexport) 
int TYPE205           (
             double &time,  // the simulation time
             double xin[],  // the array containing the component InpUTS
             double xout[], // the array which the component fills with its appropriate OUTPUTS
             double &t,     // the array containing the dependent variables for which the derivatives are evaluated 
             double &dtdt,  // the array containing the derivatives of T which are evaluated 
             double par[],  // the array containing the PARAMETERS of the component
             int info[],    // the information array described in Section 3.3.3 of the manual
             int icntrl     // the control array described in Section 3.3.4 of the manual
            )
{
  //*************************************************************************
  //*** TYPE implementation
  //*** This function will be called by TRNSYS 
  //*** - once at the beginning of the simulation for initialization
  //*** - once at the beginning of every timestep for initialization
  //*** - once for each iteration of the TRNSYS solver
  //*** - once at the end of each timestep for cleanup
  //*** - once at the end of the simulation for cleanup
  //*************************************************************************
  // 
  //***
  //*** WARNING: explanations in the TRNSYS manual use FORTRAN conventions for 
  //***          array indices. Subtract 1 to obtain 0-based C or C++ conventions. 
  //*** Example: 
  //***          TRNSYS manual: info(6) = number of OUTPUTS 
  //***          -> write no = info[5] to obtain number of outputs in C or C++
  //***
  //*** We also spell variables in lower case according to C tradition, while they
  //*** are spelled in uppercase in the TRNSYS manual (according to FORTRAN tradition)
  //*** 


//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------

  // *** STANDARD TRNSYS DECLARATIONS
  int npar= 3;   // number of parameters we expect
  int nin= 1;   // number of inputs
  int nout=4; // number of outputs
  int nder=0;   // number of derivatives
  int iunit; // UNIT number ('serial number' of the component, from the input file (the 'deck')
  int itype; // TYPE number (component number) 
  // read context information from TRNSYS
  // (uncomment lines as required)
	info[5] = nout;  // number of outputs 

	iunit = info[0]; // UNIT number
	itype = info[1]; // TYPE number

	//info[2]	; // number of INPUTS specified by the user of the component 
	//info[3]	; // number of PARAMETERS specified by the user of the component
	//info[4]	; // number of DERIVATIVES specified by the user of the component
	//info[5]	; // number of OUTPUTS specified by the user of the component

  //info[6]	; // number of iterative calls to the UNIT in the current timestep
              // -2 = initialization
              // -1	= initial call in simulation for this UNIT
	            //  0 = first call in timestep for this UNIT.
              //  1	= second call in timestep for this UNIT, etc.

	//info(7)	; // total number of calls to the UNIT in the simulation
  // *** inform TRNSYS about properties of this type
  info[8] = 1; // indicates whether TYPE depends on the passage of time: 0=no
	info[9]	= 0; //	use to allocate storage (see Section 3.5 of the TRNSYS manual): 0 = none
	// info[10]; // indicates number of discrete control variables (see Section 3.3.4 of the TRNSYS manual)
//-----------------------------------------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------------------------------------
//    ADD DECLARATIONS AND DEFINITIONS FOR THE USER-VARIABLES HERE

//-----------------------------------------------------------------------------------------------------------------------

//    PARAMETERS
      int nodes_htf;
      int nodes_shell;
      double Tini;

//    INPUTS
      double Tin;

	  //OUTPUTS declaration
	  double Tout=0.0,Tshell_top=0.0,Tshell_mid=0.0,Tshell_bot=0.0;

	  //FILE declaration
	  FILE *file1;
	  //Print to file the declaration and overwrie the file every time the simulation is run
	  if (time == 0.0 && info[6] == -2)
	  {
		  fopen_s(&file1,"check_type205.txt","w"); //Overwrite the checking file at the beginning of every simulation
	  }
	  else
	  {
		  fopen_s(&file1,"check_type205.txt","a");
	  }
	  fprintf_s(file1,"\nSection declaration, trnsys time and call %g\t%i\n",time,info[6]);
	  fclose(file1);


//-----------------------------------------------------------------------------------------------------------------------
//       READ IN THE VALUES OF THE PARAMETERS IN SEQUENTIAL ORDER
      nodes_htf=int(par[0]); //make sure that the nodes are a integers!!!
      nodes_shell=int(par[1]);
      Tini=par[2];

//-----------------------------------------------------------------------------------------------------------------------
//    RETRIEVE THE CURRENT VALUES OF THE INPUTS TO THIS MODEL FROM THE XIN ARRAY IN SEQUENTIAL ORDER

      Tin=xin[0];
	 iunit=info[0];
	 itype=info[1];

//-----------------------------------------------------------------------------------------------------------------------
//    SET THE VERSION INFORMATION FOR TRNSYS
      if (info[6]== -2) 
    {
	   info[11]=16;
     // add additional initialisation code here, if any
	   return 1;
    }
//-----------------------------------------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------------------------------------
//    DO ALL THE VERY LAST CALL OF THE SIMULATION MANIPULATIONS HERE
      if (info[7]== -1)
	  {
		  //Print on the check file that you reach the end of the simulation
		  fopen_s(&file1,"check_type205.txt","a");
		  fprintf_s(file1,"Section very last call of the simulation manipulations\n");
		  fclose(file1);
	   return 1;
	  }
//-----------------------------------------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------------------------------------
//    PERFORM ANY 'AFTER-ITERATION' MANIPULATIONS THAT ARE REQUIRED HERE
//    e.g. save variables to storage array for the next timestep
      if (info[12]>0) 
      {
		  fopen_s(&file1,"check_type205.txt","a");
		  fprintf_s(file1,"Section after iteration manipulations: saving the calculated values for the next timestep and deallocate left over variables variables\n");
		  fclose(file1);
		  //int store_size = nodes_htf*(nodes_shell+1);
		  //stored = new double[store_size];
		  //for (int i = 0; i < nodes_htf; i++)
		  //{
			 // stored[i*(nodes_shell+1)] = Thtf[i];
			 // for (int j=1;j<nodes_shell+1;j++)
			 // {
				//  stored[i*(nodes_shell+1)+j] = Tshell[i][j-1];
			 // }
		  //}
		  //delete[] Thtf;
		  //for(int i=0;i<nodes_htf;i++){delete[] Tshell[i];}
		  //delete[] Tshell;
		  //SetStorageVars(stored,&store_size,info);
		  //delete[] stored;
//	   nitems=0;
//	   stored[0]=... (if NITEMS > 0)
//        setStorageVars(STORED,NITEMS,INFO)
	     return 1;
      }
//-----------------------------------------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------------------------------------
//    DO ALL THE VERY FIRST CALL OF THE SIMULATION MANIPULATIONS HERE
      if (info[6]== -1) // first call of this component in the simulation
      {
//       SET SOME INFO ARRAY VARIABLES TO TELL THE TRNSYS ENGINE HOW THIS TYPE IS TO WORK
         info[5]=nout;				
         info[8]=1;				
	   info[9]=0;	// STORAGE FOR VERSION 16 HAS BEEN CHANGED				

//       SET THE REQUIRED NUMBER OF INPUTS, PARAMETERS AND DERIVATIVES THAT THE USER SHOULD SUPPLY IN THE INPUT FILE
//       IN SOME CASES, THE NUMBER OF VARIABLES MAY DEPEND ON THE VALUE OF PARAMETERS TO THIS MODEL....
         nin=1;
	       npar=3;
	       nder=0;
	       
//       CALL THE TYPE CHECK SUBROUTINE TO COMPARE WHAT THIS COMPONENT REQUIRES TO WHAT IS SUPPLIED IN 
//       THE TRNSYS INPUT FILE
    int dummy=1;
		TYPECK(&dummy,info,&nin,&npar,&nder);

//       SET THE NUMBER OF STORAGE SPOTS NEEDED FOR THIS COMPONENT
		int store_size = nodes_htf*(nodes_shell+1); //set the storage size to store Nhtf + Nhtf * Nshell temperatures
		SetStorageSize(&store_size,info);
		//Print on the check file in what section you are and what is happening
		fopen_s(&file1,"check_type205.txt","a");
		fprintf_s(file1,"Section very first call of the simulation manipulations: Setting the storage size %i\n",store_size);
		fclose(file1);
//         nitems=0;
//	     setStorageSize(nitems,info)

//       RETURN TO THE CALLING PROGRAM
         return 1;
      }


//-----------------------------------------------------------------------------------------------------------------------
//    DO ALL OF THE INITIAL TIMESTEP MANIPULATIONS HERE - THERE ARE NO ITERATIONS AT THE INTIAL TIME
      if (time < (getSimulationStartTime() +
       getSimulationTimeStep()/2.0)) 
       {
//       SET THE UNIT NUMBER FOR FUTURE CALLS
         iunit=info[0];
         itype=info[1];

//       CHECK THE PARAMETERS FOR PROBLEMS AND RETURN FROM THE SUBROUTINE IF AN ERROR IS FOUND
//         if(...) TYPECK(-4,INFO,0,"BAD PARAMETER #",0)

//       PERFORM ANY REQUIRED CALCULATIONS TO SET THE INITIAL VALUES OF THE OUTPUTS HERE
//		 Tout
		 xout[0]=Tini;
//		 Tshell_top
			xout[1]=Tini;
//		 Tshell_mid
			xout[2]=Tini;
//		 Tshell_bot
			xout[3]=Tini;

//       PERFORM ANY REQUIRED CALCULATIONS TO SET THE INITIAL STORAGE VARIABLES HERE
			int store_size = nodes_htf*(nodes_shell+1);
			stored = new double[store_size];
			for(int i=0;i<store_size;i++)
			{
				stored[i]=Tini;
			}
			fopen_s(&file1,"check_type205.txt","a");
			fprintf_s(file1,"Section Initial timestep manipulations: Allocate, setting initial values and saving storage array of size %i\n",store_size);
			fclose(file1);
			SetStorageVars(stored,&store_size,info);
			delete[] stored;
//         nitems=0;
//	   stored[0]=...

//       PUT THE STORED ARRAY IN THE GLOBAL STORED ARRAY
//         setStorageVars(stored,nitems,info)

//       RETURN TO THE CALLING PROGRAM
         return 1;

      }
//-----------------------------------------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------------------------------------
//    *** ITS AN ITERATIVE CALL TO THIS COMPONENT ***
//-----------------------------------------------------------------------------------------------------------------------

	    
//-----------------------------------------------------------------------------------------------------------------------
//    RETRIEVE THE VALUES IN THE STORAGE ARRAY FOR THIS ITERATION
	  fopen_s(&file1,"check_type205.txt","a");
	  fprintf_s(file1,"Section retrieve the values in the storage array\n");
	  int store_size = nodes_htf*(nodes_shell+1);
	  stored = new double[store_size];
	  GetStorageVars(stored,&store_size,info);
	  //thtf_old = new double [nodes_htf];
	  //tshell_old = new double *[nodes_htf];
	  //for (int i=0;i<nodes_htf;i++){tshell_old[i]=new double[nodes_shell];}
	  ////assign the storage values to the old array
	  //for (int i=0;i<nodes_htf;i++)
	  //{
		 // thtf_old[i] = stored[i*(nodes_shell+1)];// the values are supposed to be stored per layer so the first value is for the htf and the others are for the shell
		 // for (int j=1;j<nodes_shell+1;j++)
		 // {
			//  tshell_old[i][j-1] = stored[i*(nodes_shell+1)+j];
		 // }
	  //}
	  delete[] stored;
	  

//      nitems=
//	    getStorageVars(stored,nitems,info)
//      stored[0]=
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
//    CHECK THE INPUTS FOR PROBLEMS
//      if(...) TYPECK(-3,INFO,'BAD INPUT #',0,0)
//	if(IERROR.GT.0) RETURN 1
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
//    *** PERFORM ALL THE CALCULATION HERE FOR THIS MODEL. ***
//-----------------------------------------------------------------------------------------------------------------------

//		ADD YOUR COMPONENT EQUATIONS HERE; BASICALLY THE EQUATIONS THAT WILL
//		CALCULATE THE OUTPUTS BASED ON THE PARAMETERS AND THE INPUTS.	REFER TO
//		CHAPTER 3 OF THE TRNSYS VOLUME 1 MANUAL FOR DETAILED INFORMATION ON
//		WRITING TRNSYS COMPONENTS.

	  //create the new values arrays and calculate the new values based on the old ones
	  //if (info[6] == 0)
	  //{
		 // Thtf = new double[nodes_htf];
		 // Tshell = new double *[nodes_htf];
		 // for (int i=0;i<nodes_htf;i++){Tshell[i] = new double[nodes_shell];}
	  //}
	  //for (int i=0;i<nodes_htf;i++)
	  //{
		 // Thtf[i] = Thtf_old[i] + 1.0;
		 // for (int j=0;j<nodes_shell;j++)
		 // {
			//  Tshell[i][j] = Tshell_old[i][j] + 1.0;
		 // }
	  //}
	  //delete[] Thtf_old;
	  //for (int i=0;i<nodes_htf;i++){delete[] Tshell_old[i];}
	  //delete[] Tshell_old;

	  ////Set the outputs
	  //Tout = Thtf[nodes_htf-1];
	  //Tshell_top = Tshell[0][nodes_shell-1];
	  //Tshell_mid = Tshell[int(floor(nodes_htf/2.0))-1][nodes_shell-1];
	  //Tshell_bot = Tshell[nodes_htf-1][nodes_shell-1];

	  //close the file
	  fclose(file1);

//-----------------------------------------------------------------------------------------------------------------------

//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
//    SET THE STORAGE ARRAY AT THE END OF THIS ITERATION IF NECESSARY
//      nitmes=
//      stored(1)=
//	    setStorageVars(STORED,NITEMS,INFO)
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
//    REPORT ANY PROBLEMS THAT HAVE BEEN FOUND USING CALLS LIKE THIS:
//      MESSAGES(-1,'put your message here','MESSAGE',IUNIT,ITYPE)
//      MESSAGES(-1,'put your message here','WARNING',IUNIT,ITYPE)
//      MESSAGES(-1,'put your message here','SEVERE',IUNIT,ITYPE)
//      MESSAGES(-1,'put your message here','FATAL',IUNIT,ITYPE)
//-----------------------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------------------
//    SET THE OUTPUTS FROM THIS MODEL IN SEQUENTIAL ORDER AND GET OUT

//		 Tout
			xout[0]=Tout;
//		 Tshell_top
			xout[1]=Tshell_top;
//		 Tshell_mid
			xout[2]=Tshell_mid;
//		 Tshell_bot
			xout[3]=Tshell_bot;

//-----------------------------------------------------------------------------------------------------------------------
//    EVERYTHING IS DONE - RETURN FROM THIS SUBROUTINE AND MOVE ON
      return 1;
      }
//-----------------------------------------------------------------------------------------------------------------------
